<?php

global $bowob_ready, $bowob_gate_url, $bowob_chat_id, $bowob_chat_onlyreg, $bowob_chat_multi, $bowob_chat_always, $bowob_chat_friends, $bowob_chat_avatars, $bowob_is_page, $bowob_base_url, $bowob_icones, $bowob_icones_ext, $bowob_tabs_scrollvis, $bowob_language_object, $bowob_language;

bowobs_incfile('bowob_config');
bowobs_incfile('bowob_language');
bowobs_incfile('bowob_theme');
$bowob_is_page = false;

if(isset($bowob_gate_url) && isset($bowob_chat_id) && isset($bowob_chat_onlyreg) && isset($bowob_chat_multi) && isset($bowob_chat_always) && isset($bowob_chat_friends) && isset($bowob_chat_avatars) && isset($bowob_base_url) && isset($bowob_icones) && isset($bowob_icones_ext) && isset($bowob_tabs_scrollvis) && isset($bowob_language_object) && isset($bowob_language))
{
  $bowob_ready = true;
}
else
{
  $bowob_ready = false;
}

function bowobf_sync($sid, $ssync)
{
  global $bowob_ready, $bowob_chat_friends, $bowob_chat_avatars;

  bowobs_httphead('Cache-Control', 'no-cache, must-revalidate');
  bowobs_httphead('Content-Type', 'text/plain; charset=utf-8');
  
  if(!$bowob_ready)
  {
    exit();
  }
  
  if(!is_numeric($sid) || $ssync == '')
  {
    echo 'BoWoB: GET: no data received';
    exit();
  }
  
  $rs = bowobs_db_extract($sid, $ssync, time() - 300);

  if(!sizeof($rs))
  {
    echo 'BoWoB: GET: bad data received';
    exit();
  }

  $output = '';
  $output .= 'bowob_user: '. $rs[0] . "\n";
  $output .= 'bowob_name: ' . $rs[3] . "\n";
  if($bowob_chat_avatars)
  {
    $output .= 'bowob_avatar: ' . $rs[4] . "\n";
  }
  $output .= 'bowob_type: ' . $rs[1] . "\n";
  $output .= 'bowob_id: ' . $rs[2] . "\n";
  if($bowob_chat_friends)
  {
    $output .= 'bowob_friends_start' . "\n";
    $friends = bowobs_user_friends($rs[2], "\n");
    $output .= $friends;
    $output .= 'bowob_friends_end' . "\n";
  }
  
  echo $output;
}

function bowobf_reconnect($username)
{
  bowobs_httphead('Cache-Control', 'no-cache, must-revalidate');
  
  if(empty($username))
  {
    echo 'BoWoB: GET: no data received';
    exit();
  }
  
  echo bowobf_prepare(false, $username, 2);
}

function bowobf_profile($userid)
{
  bowobs_redirect_profile($userid);
}

function bowobf_close()
{
  $time = time();

  bowobs_httphead('Cache-Control', 'no-cache, must-revalidate');
  
  bowobf_cookie('bwc_mc', '1', $time + 31536000);
  bowobf_multi_cookie_unset();
  bowobf_cookie('bwc_si', '', $time - 31536000);
  bowobs_redirect_index();
}

function bowobf_enable()
{
  bowobs_enable();
}

function bowobf_disable()
{
  bowobs_disable();
}

function bowobf_login()
{
  global $bowob_ready, $bowob_chat_id, $bowob_chat_onlyreg;
  
  if(!$bowob_ready)
  {
    return;
  }
  
  if($bowob_chat_id == 0)
  {
    return;
  }
  
  $user_logued = bowobs_user_logued();
  
  if($bowob_chat_onlyreg || $user_logued)
  {
    bowobf_loginsubmit('');
  }
  else
  {
    return bowobs_form_login();
  }
}

function bowobf_loginsubmit($username)
{
  bowobf_prepare(true, $username, 1);
}

function bowobf_linkblock()
{
  global $bowob_ready, $bowob_chat_id;
  
  if(!$bowob_ready)
  {
    return;
  }
  
  if($bowob_chat_id == 0)
  {
    return;
  }
  
  return bowobs_form_blocklink();
}

function bowobf_loginblock()
{
  global $bowob_ready, $bowob_chat_id, $bowob_chat_onlyreg;
  
  if(!$bowob_ready)
  {
    return;
  }
  
  if($bowob_chat_id == 0)
  {
    return;
  }
  
  $user_logued = bowobs_user_logued();
  
  if($bowob_chat_onlyreg || $user_logued)
  {
    $output = bowobs_form_blocklink();
  }
  else
  {
    $output = bowobs_form_blocklogin();
  }

  return $output;
}

function bowobf_cookie($name, $value, $time)
{
  global $bowob_ready, $bowob_base_url;
  
  if(!$bowob_ready)
  {
    return;
  }
  
  if($bowob_base_url == '')
  {
    return;
  }
  $url = parse_url($bowob_base_url);
  
  bowobs_cookie_set($name, $value, $time, $url['path'], '.' . $url['host']);
}

function bowobf_syncdata($user, $name, $avatar, $type, $user_id)
{
  $time = time();
  $pattern = '1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
  $sync = '';
  
  for($i = 0; $i < 50; $i ++)
  {
    $sync .= $pattern[rand(0, 61)];
  }
  
  $id = bowobs_db_insert($sync, $time, $user, $name, $avatar, $type, $user_id);
  
  return array($id, $sync);
}

function bowobf_showdata($id, $sync)
{
  return '{id: "' . $id . '", sync: "' . $sync . '"}';
}

function bowobf_showchat($username)
{
  global $bowob_ready, $bowob_gate_url, $bowob_chat_id, $bowob_chat_multi, $bowob_icones, $bowob_icones_ext, $bowob_tabs_scrollvis, $bowob_language_object, $bowob_language;
  
  if(!$bowob_ready)
  {
    return '';
  }
  
  $output = '';
  
  if(bowobf_cookie_get('bwc_lc', '') == '')
  {
    $output .= '<script type="text/javascript" src="' . $bowob_gate_url . 'loader/' . $bowob_chat_id . '/bl_1"></script>';
  }
  
  $chat_data = bowobf_cookie_get('bwc_l', '');
  if($chat_data != '')
  {
    $output .= '<div id="bowob">' . "\n";

    $output .= '<div id="bowob_bar"></div>' . "\n";
    $output .= '<div id="bowob_config"></div>' . "\n";
    $output .= '<div id="bowob_head"></div>' . "\n";
    $output .= '<div id="bowob_tabs"></div>' . "\n";
    $output .= '<div id="bowob_head_window"></div>' . "\n";
    $output .= '<div id="bowob_config_window"></div>' . "\n";
    $output .= '<div id="bowob_window"></div>' . "\n";

    $output .= '<script language="javascript">';
  
    $output .= 'bowob_icones = new Array();';
    $output .= 'bowob_icones_ext = new Array();';
    $output .= 'bowob_language = new Object();';
    $output .= 'bowob_sounds = new Array();';
  
    for($j = 0; $j < sizeof($bowob_icones); $j ++)
    {
      $output .= 'bowob_icones[' . $j . '] = "' . str_replace('"', '\\"', str_replace('\\', '\\\\', $bowob_icones[$j])) . '";';
      $output .= 'bowob_icones_ext[' . $j . '] = "' . $bowob_icones_ext[$j] . '";';
    }
  
    for($j = 0; $j < sizeof($bowob_language); $j ++)
    {
      $output .= 'bowob_language.' . $bowob_language_object[$j] . ' = "' . str_replace('"', '\\"', str_replace('\\', '\\\\', $bowob_language[$j])) . '";';
    }
    
    $output .= 'bowob_tabs_scrollvis = ' . $bowob_tabs_scrollvis . ';';
  
    $output .= '</script>';
    $output .= '<noscript>NOSCRIPT: This content requires JavaScript.</noscript>';
    
    $chat_data = str_replace('-bl_r1-', 'script', $chat_data);
    $chat_data = str_replace('-bl_r2-', 'type', $chat_data);
    $chat_data = str_replace('-bl_r3-', 'src', $chat_data);
    $chat_data = str_replace('@bwl_n@', str_replace('"', '\\"', str_replace('\\', '\\\\', $username)), $chat_data);
    $chat_data = str_replace('@bwl_m@', urlencode($username), $chat_data);
    
    $output .= "\n" . $chat_data;

    $output .= '</div>' . "\n";
  }

  return $output;
}

function bowobf_prepare($is_bowob_page, $username, $type)
{
  global $bowob_ready, $bowob_chat_onlyreg, $bowob_chat_multi, $bowob_is_page, $bowob_chat_avatars;
  
  if(!$bowob_ready)
  {
    return -1;
  }
  
  $time = time();
  
  $user_logued = bowobs_user_logued();
  $user_name = bowobs_user_name();
  if($user_name == '')
  {
    $user_name = $username;
  }
  
  $sync_logued = false;
  if(bowobf_cookie_get('bwc_sl', '') == '1')
  {
    $sync_logued = true;
  }
  
  if(bowobf_cookie_get('bwc_si', '') != '' && bowobf_cookie_get('bwc_ss', '') != '' && bowobf_cookie_get('bwc_su', '') == $user_name && $sync_logued == $user_logued && !$is_bowob_page)
  {
    return bowobf_showchat($user_name);
  }

  if($bowob_chat_onlyreg)
  {
    if(!$user_logued || !bowobs_user_logued_validate())
    {
      if($is_bowob_page)
      {
        bowobs_redirect_login();
      }
      elseif(bowobf_alwayscookie())
      {
        return -1;
      }
      return;
    }
  }
  else
  {
    if(!$user_logued)
    {
      $error_type = bowobs_user_validate($user_name);
      if($error_type)
      {
        if($is_bowob_page)
        {
          bowobs_form_error($error_type, $user_name);
        }
        elseif(bowobf_alwayscookie())
        {
          return -1;
        }
        return;
      }
    }
  }
  
  if($bowob_chat_multi)
  {
    bowobf_multi_cookie_set($user_name);
    if($is_bowob_page)
    {
      bowobs_redirect_index();
    }
  }

  if($user_logued)
  {
    $user_type = 0;
    $sync_logued = '1';
  }
  else
  {
    $user_type = 1;
    $sync_logued = '0';
  }
  
  bowobf_cookie('bwc_sl', $sync_logued, $time + 31536000);
  bowobf_cookie('bwc_si', '', $time - 31536000);
  
  if($type != 1)
  {
    $bowob_data = bowobf_syncdata($user_name, bowobs_user_visiblename(), ($bowob_chat_avatars ? bowobs_user_avatar() : ''), $user_type, bowobs_user_id());
    echo bowobf_showdata($bowob_data[0], $bowob_data[1]);
    exit();
  }
  if($is_bowob_page)
  {
    $bowob_is_page = true;
  }
  return bowobf_showchat($user_name);
}

function bowobf_alwayscookie()
{
  global $bowob_ready, $bowob_chat_onlyreg, $bowob_multi_show, $bowob_multi_nick, $bowob_chat_always, $bowob_language_object, $bowob_language;
  
  if(!$bowob_ready)
  {
    return false;
  }
  
  $user_logued = bowobs_user_logued();
  $user_name = bowobs_user_name();

  if(!$bowob_chat_always || bowobf_cookie_get('bwc_mc', '') != '')
  {
    $bowob_multi_show = false;
    bowobf_multi_cookie_unset();
    return false;
  }

  if($bowob_chat_onlyreg)
  {
    if(!$user_logued)
    {
      $bowob_multi_show = false;
      bowobf_multi_cookie_unset();
      return false;
    }
  }
  else
  {
    if(!$user_logued)
    {
      $guest_username = 'guest';
      for($i = 0; $i < sizeof($bowob_language_object); $i ++)
      {
        if($bowob_language_object[$i] == 'lang_user_guest')
        {
          $guest_username = $bowob_language[$i];
          break;
        }
      }
  
      $user_name = $guest_username . '_' . rand(0, 99999999);
    }
  }

  bowobf_multi_cookie_set($user_name);
  $bowob_multi_show = true;
  $bowob_multi_nick = $user_name;

  return true;
}

function bowobf_multi_cookie_set($username)
{
  $time = time();
  bowobf_cookie('bwc_mn', $username, $time + 31536000);
  bowobf_cookie('bwc_mc', '', $time - 31536000);
}

function bowobf_multi_cookie_unset()
{
  $time = time();
  bowobf_cookie('bwc_mn', '', $time - 31536000);
}

function bowobf_cookie_get($name, $default)
{
  return bowobs_cookie_get($name, $default);
}

function bowobf_multi_show()
{
  global $bowob_ready, $bowob_multi_show, $bowob_is_page, $bowob_multi_nick, $bowob_chat_multi;
  
  if(!$bowob_ready)
  {
    return '';
  }
  
  $user_logued = bowobs_user_logued();
  $user_name = bowobs_user_name();
  $bowob_multi_show = false;
  $output = '';

  if(!$bowob_is_page)
  {
    if($bowob_chat_multi)
    {
      $cookie_name = bowobf_cookie_get('bwc_mn', '');
      if($cookie_name != '')
      {
        $bowob_multi_show = true;
        if($user_logued && $cookie_name != $user_name)
        {
          $bowob_multi_nick = $user_name;
          bowobf_multi_cookie_set($bowob_multi_nick);
        }
        else
        {
          $bowob_multi_nick = $cookie_name;
        }
      }
      else
      {
        bowobf_alwayscookie();
      }
    }
  }

  if($bowob_multi_show)
  {
    $aux = bowobf_prepare(false, $bowob_multi_nick, 1);
    if($aux == -1)
    {
      $aux = bowobf_prepare(false, $bowob_multi_nick, 1);
    }
    if($aux != -1)
    {
      $output .= $aux;
    }
  }
  
  return $output;
}

function bowobf_stylesheet()
{
  global $bowob_ready, $bowob_base_url;
  
  if(!$bowob_ready)
  {
    return;
  }
  
  bowobs_stylesheet($bowob_base_url, 'bowob_theme/bowob-style.css', 'bowob_style');
  bowobs_stylesheet($bowob_base_url, 'bowob_theme/bowob-style_ie6.css', 'bowob_style_ie6', 'lte IE 6');
}

?>